package com.wcs.timerreqscopebug;

import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

/**
 *
 * @author kumm
 */
@Stateless
public class Fixture {
    @PersistenceContext
    EntityManager em;
    
    public void setUp() {
        if (!isEmpty()) {
            return;
        }
        System.out.println("Fixture setUp...");
        for(int i=0; i<100; i++) {
            Person person = new Person();
            person.setName("Name "+i);
            em.persist(person);
            for(int j=0; j<100; j++) {
                Phone phone = new Phone();
                phone.setPerson(person);
                phone.setNumber("Numb "+j);
                em.persist(phone);
            }
        }
    }
    
    private boolean isEmpty() {
        CriteriaBuilder cb = em.getCriteriaBuilder();
        CriteriaQuery<Long> cq = cb.createQuery(Long.class);
        Root root = cq.from(Person.class);
        cq.select(cb.count(root));
        return em.createQuery(cq).getSingleResult() == 0l;
    }
}
