package com.wcs.timerreqscopebug;

import java.util.List;
import java.util.logging.Logger;
import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

/**
 *
 * @author kumm
 */
@RequestScoped
public class RequestBean {
    @PersistenceContext
    EntityManager em;
    private static final Logger logger = Logger.getLogger(RequestBean.class.getName());
    
    @PostConstruct
    public void init() {
        logger.info("RequestBean created on "+Thread.currentThread().getName());
    }
    
    public void doIt() {
        List<Phone> resultList = query();
        System.out.println("Resultlist size: "+resultList.size());
        for (Phone phone : resultList) {
            if (phone.getPerson()==null) {
                logger.severe("BUG at "+phone+" on "+Thread.currentThread().getName());
            }
        }
    }
    
    private List<Phone> query() {
        CriteriaBuilder cb = em.getCriteriaBuilder();      
        CriteriaQuery<Phone> cq = cb.createQuery(Phone.class);
        Root root = cq.from(Phone.class);
        root.fetch(Phone_.person);
        return em.createQuery(cq).getResultList();
        
    }
}
