package com.wcs.timerreqscopebug;

import java.util.Date;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.ejb.Timeout;
import javax.ejb.TimerConfig;
import javax.ejb.TimerService;
import javax.inject.Inject;

/**
 *
 * @author kumm
 */
@Stateless
public class Timer {
    @Inject
    RequestBean requestBean;
    @Resource
    private TimerService timerService;
    private static final Logger logger = Logger.getLogger(Timer.class.getName());
    
    public void init() {
        Date t0 = new Date( System.currentTimeMillis()+1000 );
        timerService.createIntervalTimer(t0, 1000, new  TimerConfig("Timer1", false));
        timerService.createIntervalTimer(t0, 1000, new  TimerConfig("Timer2", false));
    }
    
    @Timeout
    public void timeout(javax.ejb.Timer timer) {
        logger.info("timeout start "+timer.getInfo()+" on "+Thread.currentThread().getName());
        requestBean.doIt();
        logger.info("timeout stop "+timer.getInfo()+" on "+Thread.currentThread().getName());
    }
    
}
